/*
 *  ==== DO NOT MODIFY THIS FILE - CHANGES WILL BE OVERWRITTEN ====
 *
 *  Generated from
 *      C:/Program Files/Texas Instruments/grace_1_00_01_83/packages/ti/mcu/msp430/csl/adc/ADC10_init.xdt
 */

#include <ti/mcu/msp430/include/msp430.h>

extern unsigned int ADCdata[];  /* user specified external buffer */

/*
 *  ======== ADC10_init ========
 *  Initialize MSP430 10-bit Analog to Digital Converter
 */
void ADC10_init(void)
{
    /* disable ADC10 during initialization */
    ADC10CTL0 &= ~ENC;

    /* 
     * Control Register 0
     * 
     * ~ADC10SC -- No conversion
     * ~ENC -- Disable ADC
     * ~ADC10IFG -- Clear ADC interrupt flag
     * ~ADC10IE -- Disable ADC interrupt
     * ADC10ON -- Switch On ADC10
     * ~REFON -- Disable ADC reference generator
     * ~REF2_5V -- Set reference voltage generator = 1.5V
     * ~MSC -- Disable multiple sample and conversion
     * ~REFBURST -- Reference buffer on continuously
     * ~REFOUT -- Reference output off
     * ~ADC10SR -- Reference buffer supports up to ~200 ksps
     * ADC10SHT_3 -- 64 x ADC10CLKs
     * SREF_0 -- VR+ = VCC and VR- = VSS
     * 
     * Note: ~<BIT> indicates that <BIT> has value zero
     */
    ADC10CTL0 = ADC10ON + ADC10SHT_3 + SREF_0;
    
    /* 
     * Control Register 1
     * 
     * ~ADC10BUSY -- No operation is active
     * CONSEQ_0 -- Single channel single conversion
     * ADC10SSEL_1 -- ACLK
     * ADC10DIV_0 -- Divide by 1
     * ~ISSH -- Input signal not inverted
     * ~ADC10DF -- ADC10 Data Format as binary
     * SHS_0 -- ADC10SC
     * INCH_12 -- ADC Channel 12
     * 
     * Note: ~<BIT> indicates that <BIT> has value zero
     */
    ADC10CTL1 = CONSEQ_0 + ADC10SSEL_1 + ADC10DIV_0 + SHS_0 + INCH_12;
    
    /* Analog (Input) Enable Control Register 0 */
    ADC10AE0 = 0x1;
    
    /* 
     * Data Transfer Control Register 0
     * 
     * ~ADC10TB -- One-block transfer mode
     * ADC10CT -- Data is transferred continuously after every conversion
     * 
     * Note: ~ADC10TB indicates that ADC10TB has value zero
     */
    ADC10DTC0 = ADC10CT;
    
    /* Data Transfer Control Register 1 */
    ADC10DTC1 = 2;
    
    /* Data Transfer Start Address */
    ADC10SA = (unsigned int)ADCdata;
    
    /* enable ADC10 */
    ADC10CTL0 |= ENC;
}
